package com.sun.org.apache.bcel.internal.generic;

import com.sun.org.apache.bcel.internal.util.ByteSequence;
import java.io.IOException;
import java.io.DataOutputStream;

public class JSR_W extends JsrInstruction
{
    JSR_W() {
    }
    
    public JSR_W(InstructionHandle target) {
        super((short)201, target);
        super.setLength(5);
    }
    
    @Override
    public void dump(DataOutputStream out) throws IOException {
        super.setIndex(this.getTargetOffset());
        out.writeByte((int)super.getOpcode());
        out.writeInt(super.getIndex());
    }
    
    @Override
    protected void initFromFile(ByteSequence bytes, boolean wide) throws IOException {
        super.setIndex(bytes.readInt());
        super.setLength(5);
    }
    
    @Override
    public void accept(Visitor v) {
        v.visitStackProducer(this);
        v.visitBranchInstruction(this);
        v.visitJsrInstruction(this);
        v.visitJSR_W(this);
    }
}
